Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.Designer.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.Designer.cs	(revision 7577)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.Designer.cs	(revision 7578)
@@ -80,5 +80,5 @@
       this.label1.Name = "label1";
       this.label1.Size = new System.Drawing.Size(111, 13);
-      this.label1.TabIndex = 1;
+      this.label1.TabIndex = 0;
       this.label1.Text = "Choose a subscription";
       // 
@@ -89,5 +89,5 @@
       this.cmbChooseSubscription.Name = "cmbChooseSubscription";
       this.cmbChooseSubscription.Size = new System.Drawing.Size(486, 21);
-      this.cmbChooseSubscription.TabIndex = 2;
+      this.cmbChooseSubscription.TabIndex = 0;
       this.cmbChooseSubscription.SelectedValueChanged += new System.EventHandler(this.cmbChooseSubscription_SelectedValueChanged);
       // 
@@ -98,5 +98,5 @@
       this.label2.Name = "label2";
       this.label2.Size = new System.Drawing.Size(124, 13);
-      this.label2.TabIndex = 5;
+      this.label2.TabIndex = 1;
       this.label2.Text = "Choose a hosted service";
       // 
@@ -107,5 +107,5 @@
       this.cmbChooseHostedService.Name = "cmbChooseHostedService";
       this.cmbChooseHostedService.Size = new System.Drawing.Size(486, 21);
-      this.cmbChooseHostedService.TabIndex = 6;
+      this.cmbChooseHostedService.TabIndex = 1;
       this.cmbChooseHostedService.Validating += new System.ComponentModel.CancelEventHandler(this.cmbChooseHostedService_Validating);
       // 
@@ -125,5 +125,5 @@
       this.gbNewHostedService.Name = "gbNewHostedService";
       this.gbNewHostedService.Size = new System.Drawing.Size(486, 145);
-      this.gbNewHostedService.TabIndex = 7;
+      this.gbNewHostedService.TabIndex = 3;
       this.gbNewHostedService.TabStop = false;
       this.gbNewHostedService.Text = "New hosted service";
@@ -143,5 +143,5 @@
       this.cmbLocation.Name = "cmbLocation";
       this.cmbLocation.Size = new System.Drawing.Size(200, 21);
-      this.cmbLocation.TabIndex = 8;
+      this.cmbLocation.TabIndex = 7;
       // 
       // rbAffinitGroup
@@ -151,5 +151,5 @@
       this.rbAffinitGroup.Name = "rbAffinitGroup";
       this.rbAffinitGroup.Size = new System.Drawing.Size(14, 13);
-      this.rbAffinitGroup.TabIndex = 7;
+      this.rbAffinitGroup.TabIndex = 8;
       this.rbAffinitGroup.UseVisualStyleBackColor = true;
       // 
@@ -223,5 +223,5 @@
       this.cbNewHostedService.Name = "cbNewHostedService";
       this.cbNewHostedService.Size = new System.Drawing.Size(152, 17);
-      this.cbNewHostedService.TabIndex = 8;
+      this.cbNewHostedService.TabIndex = 2;
       this.cbNewHostedService.Text = "Create new hosted service";
       this.cbNewHostedService.UseVisualStyleBackColor = true;
@@ -256,5 +256,5 @@
       this.btnAddCertificate.Name = "btnAddCertificate";
       this.btnAddCertificate.Size = new System.Drawing.Size(99, 23);
-      this.btnAddCertificate.TabIndex = 11;
+      this.btnAddCertificate.TabIndex = 7;
       this.btnAddCertificate.Text = "Add certificate";
       this.btnAddCertificate.UseVisualStyleBackColor = true;
@@ -267,5 +267,5 @@
       this.label9.Name = "label9";
       this.label9.Size = new System.Drawing.Size(186, 13);
-      this.label9.TabIndex = 12;
+      this.label9.TabIndex = 9;
       this.label9.Text = "How many instances should be used?";
       // 
@@ -275,5 +275,5 @@
       this.tbInstanceCount.Name = "tbInstanceCount";
       this.tbInstanceCount.Size = new System.Drawing.Size(488, 20);
-      this.tbInstanceCount.TabIndex = 13;
+      this.tbInstanceCount.TabIndex = 12;
       this.tbInstanceCount.Validating += new System.ComponentModel.CancelEventHandler(this.tbInstanceCount_Validating);
       // 
@@ -284,5 +284,5 @@
       this.lblCores.Name = "lblCores";
       this.lblCores.Size = new System.Drawing.Size(30, 13);
-      this.lblCores.TabIndex = 14;
+      this.lblCores.TabIndex = 11;
       this.lblCores.Text = "0 / 0";
       // 
@@ -293,5 +293,5 @@
       this.label10.Name = "label10";
       this.label10.Size = new System.Drawing.Size(40, 13);
-      this.label10.TabIndex = 15;
+      this.label10.TabIndex = 10;
       this.label10.Text = "Cores: ";
       // 
@@ -310,5 +310,5 @@
       this.btnOk.Name = "btnOk";
       this.btnOk.Size = new System.Drawing.Size(75, 23);
-      this.btnOk.TabIndex = 17;
+      this.btnOk.TabIndex = 13;
       this.btnOk.Text = "OK";
       this.btnOk.UseVisualStyleBackColor = true;
@@ -320,5 +320,5 @@
       this.btnCancel.Name = "btnCancel";
       this.btnCancel.Size = new System.Drawing.Size(75, 23);
-      this.btnCancel.TabIndex = 18;
+      this.btnCancel.TabIndex = 14;
       this.btnCancel.Text = "Cancel";
       this.btnCancel.UseVisualStyleBackColor = true;
@@ -331,5 +331,5 @@
       this.lblCertificateFile.Name = "lblCertificateFile";
       this.lblCertificateFile.Size = new System.Drawing.Size(0, 13);
-      this.lblCertificateFile.TabIndex = 19;
+      this.lblCertificateFile.TabIndex = 8;
       // 
       // errorProvider
@@ -347,5 +347,5 @@
       this.gbStorageService.Name = "gbStorageService";
       this.gbStorageService.Size = new System.Drawing.Size(486, 128);
-      this.gbStorageService.TabIndex = 20;
+      this.gbStorageService.TabIndex = 4;
       this.gbStorageService.TabStop = false;
       this.gbStorageService.Text = "Set storage service";
@@ -359,5 +359,5 @@
       this.cbCreateBlobIfNotExists.Name = "cbCreateBlobIfNotExists";
       this.cbCreateBlobIfNotExists.Size = new System.Drawing.Size(182, 17);
-      this.cbCreateBlobIfNotExists.TabIndex = 21;
+      this.cbCreateBlobIfNotExists.TabIndex = 4;
       this.cbCreateBlobIfNotExists.Text = "Create blob container if not exists";
       this.cbCreateBlobIfNotExists.UseVisualStyleBackColor = true;
@@ -368,5 +368,5 @@
       this.tbBlobContainer.Name = "tbBlobContainer";
       this.tbBlobContainer.Size = new System.Drawing.Size(452, 20);
-      this.tbBlobContainer.TabIndex = 10;
+      this.tbBlobContainer.TabIndex = 3;
       this.tbBlobContainer.Validating += new System.ComponentModel.CancelEventHandler(this.tbBlobContainer_Validating);
       // 
@@ -377,5 +377,5 @@
       this.label11.Name = "label11";
       this.label11.Size = new System.Drawing.Size(96, 13);
-      this.label11.TabIndex = 11;
+      this.label11.TabIndex = 2;
       this.label11.Text = "Set blob container:";
       // 
@@ -386,5 +386,5 @@
       this.cmbStorageServices.Name = "cmbStorageServices";
       this.cmbStorageServices.Size = new System.Drawing.Size(452, 21);
-      this.cmbStorageServices.TabIndex = 10;
+      this.cmbStorageServices.TabIndex = 1;
       this.cmbStorageServices.Validating += new System.ComponentModel.CancelEventHandler(this.cmbStorageServices_Validating);
       // 
@@ -395,5 +395,5 @@
       this.label8.Name = "label8";
       this.label8.Size = new System.Drawing.Size(120, 13);
-      this.label8.TabIndex = 10;
+      this.label8.TabIndex = 0;
       this.label8.Text = "Select storage account:";
       // 
@@ -454,5 +454,5 @@
       this.gbDeploymentOptions.Name = "gbDeploymentOptions";
       this.gbDeploymentOptions.Size = new System.Drawing.Size(486, 69);
-      this.gbDeploymentOptions.TabIndex = 22;
+      this.gbDeploymentOptions.TabIndex = 5;
       this.gbDeploymentOptions.TabStop = false;
       this.gbDeploymentOptions.Text = "Deployment options";
@@ -467,5 +467,5 @@
       this.gbVMSize.Name = "gbVMSize";
       this.gbVMSize.Size = new System.Drawing.Size(486, 118);
-      this.gbVMSize.TabIndex = 23;
+      this.gbVMSize.TabIndex = 6;
       this.gbVMSize.TabStop = false;
       this.gbVMSize.Text = "Virtual machine size";