Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs	(revision 7331)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs	(revision 7589)
@@ -50,7 +50,10 @@
       this.runCollectionView = new HeuristicLab.Optimization.Views.RunCollectionView();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
+      this.filterTabControl = new System.Windows.Forms.TabControl();
+      this.filterTabPage = new System.Windows.Forms.TabPage();
       this.filtersGroupBox = new System.Windows.Forms.GroupBox();
       this.filterPanel = new System.Windows.Forms.Panel();
       this.refreshFiltersButton = new System.Windows.Forms.Button();
+      this.constraintsTabPage = new System.Windows.Forms.TabPage();
       this.resultsGroupBox = new System.Windows.Forms.GroupBox();
       this.includeBinaryValuesCheckBox = new System.Windows.Forms.CheckBox();
@@ -61,9 +64,15 @@
       this.filtersInfoPanel = new System.Windows.Forms.Panel();
       this.filtersInfoLabel = new System.Windows.Forms.Label();
+      this.constraintsCheckedListBox = new System.Windows.Forms.CheckedListBox();
+      this.selectAllButton = new System.Windows.Forms.Button();
+      this.deselectAllButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
       this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
+      this.filterTabControl.SuspendLayout();
+      this.filterTabPage.SuspendLayout();
       this.filtersGroupBox.SuspendLayout();
+      this.constraintsTabPage.SuspendLayout();
       this.resultsGroupBox.SuspendLayout();
       this.resultsInfoPanel.SuspendLayout();
@@ -106,5 +115,5 @@
       // splitContainer.Panel1
       // 
-      this.splitContainer.Panel1.Controls.Add(this.filtersGroupBox);
+      this.splitContainer.Panel1.Controls.Add(this.filterTabControl);
       // 
       // splitContainer.Panel2
@@ -115,4 +124,28 @@
       this.splitContainer.TabIndex = 0;
       // 
+      // filterTabControl
+      // 
+      this.filterTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.filterTabControl.Controls.Add(this.filterTabPage);
+      this.filterTabControl.Controls.Add(this.constraintsTabPage);
+      this.filterTabControl.Location = new System.Drawing.Point(3, 3);
+      this.filterTabControl.Name = "filterTabControl";
+      this.filterTabControl.SelectedIndex = 0;
+      this.filterTabControl.Size = new System.Drawing.Size(832, 276);
+      this.filterTabControl.TabIndex = 1;
+      // 
+      // filterTabPage
+      // 
+      this.filterTabPage.Controls.Add(this.filtersGroupBox);
+      this.filterTabPage.Location = new System.Drawing.Point(4, 22);
+      this.filterTabPage.Name = "filterTabPage";
+      this.filterTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.filterTabPage.Size = new System.Drawing.Size(824, 250);
+      this.filterTabPage.TabIndex = 0;
+      this.filterTabPage.Text = "Filter";
+      this.filterTabPage.UseVisualStyleBackColor = true;
+      // 
       // filtersGroupBox
       // 
@@ -122,7 +155,7 @@
       this.filtersGroupBox.Controls.Add(this.filterPanel);
       this.filtersGroupBox.Controls.Add(this.refreshFiltersButton);
-      this.filtersGroupBox.Location = new System.Drawing.Point(0, 0);
+      this.filtersGroupBox.Location = new System.Drawing.Point(6, 6);
       this.filtersGroupBox.Name = "filtersGroupBox";
-      this.filtersGroupBox.Size = new System.Drawing.Size(838, 279);
+      this.filtersGroupBox.Size = new System.Drawing.Size(812, 238);
       this.filtersGroupBox.TabIndex = 0;
       this.filtersGroupBox.TabStop = false;
@@ -136,5 +169,5 @@
       this.filterPanel.Location = new System.Drawing.Point(6, 19);
       this.filterPanel.Name = "filterPanel";
-      this.filterPanel.Size = new System.Drawing.Size(796, 254);
+      this.filterPanel.Size = new System.Drawing.Size(770, 213);
       this.filterPanel.TabIndex = 1;
       // 
@@ -143,5 +176,5 @@
       this.refreshFiltersButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.refreshFiltersButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
-      this.refreshFiltersButton.Location = new System.Drawing.Point(808, 21);
+      this.refreshFiltersButton.Location = new System.Drawing.Point(782, 21);
       this.refreshFiltersButton.Name = "refreshFiltersButton";
       this.refreshFiltersButton.Size = new System.Drawing.Size(24, 24);
@@ -149,4 +182,17 @@
       this.refreshFiltersButton.UseVisualStyleBackColor = true;
       this.refreshFiltersButton.Click += new System.EventHandler(this.refreshFiltersButton_Click);
+      // 
+      // constraintsTabPage
+      // 
+      this.constraintsTabPage.Controls.Add(this.deselectAllButton);
+      this.constraintsTabPage.Controls.Add(this.selectAllButton);
+      this.constraintsTabPage.Controls.Add(this.constraintsCheckedListBox);
+      this.constraintsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.constraintsTabPage.Name = "constraintsTabPage";
+      this.constraintsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.constraintsTabPage.Size = new System.Drawing.Size(824, 250);
+      this.constraintsTabPage.TabIndex = 1;
+      this.constraintsTabPage.Text = "Downloaded Values";
+      this.constraintsTabPage.UseVisualStyleBackColor = true;
       // 
       // resultsGroupBox
@@ -245,4 +291,39 @@
       this.filtersInfoLabel.Text = "Loading Filters ...";
       this.filtersInfoLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      // 
+      // constraintsCheckedListBox
+      // 
+      this.constraintsCheckedListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.constraintsCheckedListBox.CheckOnClick = true;
+      this.constraintsCheckedListBox.FormattingEnabled = true;
+      this.constraintsCheckedListBox.Location = new System.Drawing.Point(6, 6);
+      this.constraintsCheckedListBox.Name = "constraintsCheckedListBox";
+      this.constraintsCheckedListBox.Size = new System.Drawing.Size(812, 214);
+      this.constraintsCheckedListBox.Sorted = true;
+      this.constraintsCheckedListBox.TabIndex = 0;
+      // 
+      // selectAllButton
+      // 
+      this.selectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.selectAllButton.Location = new System.Drawing.Point(6, 221);
+      this.selectAllButton.Name = "selectAllButton";
+      this.selectAllButton.Size = new System.Drawing.Size(75, 23);
+      this.selectAllButton.TabIndex = 1;
+      this.selectAllButton.Text = "Select all";
+      this.selectAllButton.UseVisualStyleBackColor = true;
+      this.selectAllButton.Click += new System.EventHandler(this.selectAllButton_Click);
+      // 
+      // deselectAllButton
+      // 
+      this.deselectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.deselectAllButton.Location = new System.Drawing.Point(88, 221);
+      this.deselectAllButton.Name = "deselectAllButton";
+      this.deselectAllButton.Size = new System.Drawing.Size(75, 23);
+      this.deselectAllButton.TabIndex = 2;
+      this.deselectAllButton.Text = "Deselect all";
+      this.deselectAllButton.UseVisualStyleBackColor = true;
+      this.deselectAllButton.Click += new System.EventHandler(this.deselectAllButton_Click);
       // 
       // QueryView
@@ -259,5 +340,8 @@
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
+      this.filterTabControl.ResumeLayout(false);
+      this.filterTabPage.ResumeLayout(false);
       this.filtersGroupBox.ResumeLayout(false);
+      this.constraintsTabPage.ResumeLayout(false);
       this.resultsGroupBox.ResumeLayout(false);
       this.resultsGroupBox.PerformLayout();
@@ -285,4 +369,10 @@
     private System.Windows.Forms.Button refreshFiltersButton;
     private System.Windows.Forms.CheckBox includeBinaryValuesCheckBox;
+    private System.Windows.Forms.TabControl filterTabControl;
+    private System.Windows.Forms.TabPage filterTabPage;
+    private System.Windows.Forms.TabPage constraintsTabPage;
+    private System.Windows.Forms.Button deselectAllButton;
+    private System.Windows.Forms.Button selectAllButton;
+    private System.Windows.Forms.CheckedListBox constraintsCheckedListBox;
 
   }