Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs	(revision 7589)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Query/Views/QueryView.Designer.cs	(revision 7590)
@@ -56,4 +56,7 @@
       this.refreshFiltersButton = new System.Windows.Forms.Button();
       this.constraintsTabPage = new System.Windows.Forms.TabPage();
+      this.deselectAllButton = new System.Windows.Forms.Button();
+      this.selectAllButton = new System.Windows.Forms.Button();
+      this.constraintsCheckedListBox = new System.Windows.Forms.CheckedListBox();
       this.resultsGroupBox = new System.Windows.Forms.GroupBox();
       this.includeBinaryValuesCheckBox = new System.Windows.Forms.CheckBox();
@@ -64,7 +67,4 @@
       this.filtersInfoPanel = new System.Windows.Forms.Panel();
       this.filtersInfoLabel = new System.Windows.Forms.Label();
-      this.constraintsCheckedListBox = new System.Windows.Forms.CheckedListBox();
-      this.selectAllButton = new System.Windows.Forms.Button();
-      this.deselectAllButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -145,5 +145,5 @@
       this.filterTabPage.Size = new System.Drawing.Size(824, 250);
       this.filterTabPage.TabIndex = 0;
-      this.filterTabPage.Text = "Filter";
+      this.filterTabPage.Text = "Filters";
       this.filterTabPage.UseVisualStyleBackColor = true;
       // 
@@ -193,6 +193,41 @@
       this.constraintsTabPage.Size = new System.Drawing.Size(824, 250);
       this.constraintsTabPage.TabIndex = 1;
-      this.constraintsTabPage.Text = "Downloaded Values";
+      this.constraintsTabPage.Text = "Limit Downloaded Values";
       this.constraintsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // deselectAllButton
+      // 
+      this.deselectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.deselectAllButton.Location = new System.Drawing.Point(88, 221);
+      this.deselectAllButton.Name = "deselectAllButton";
+      this.deselectAllButton.Size = new System.Drawing.Size(75, 23);
+      this.deselectAllButton.TabIndex = 2;
+      this.deselectAllButton.Text = "Deselect all";
+      this.deselectAllButton.UseVisualStyleBackColor = true;
+      this.deselectAllButton.Click += new System.EventHandler(this.deselectAllButton_Click);
+      // 
+      // selectAllButton
+      // 
+      this.selectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.selectAllButton.Location = new System.Drawing.Point(6, 221);
+      this.selectAllButton.Name = "selectAllButton";
+      this.selectAllButton.Size = new System.Drawing.Size(75, 23);
+      this.selectAllButton.TabIndex = 1;
+      this.selectAllButton.Text = "Select all";
+      this.selectAllButton.UseVisualStyleBackColor = true;
+      this.selectAllButton.Click += new System.EventHandler(this.selectAllButton_Click);
+      // 
+      // constraintsCheckedListBox
+      // 
+      this.constraintsCheckedListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.constraintsCheckedListBox.CheckOnClick = true;
+      this.constraintsCheckedListBox.FormattingEnabled = true;
+      this.constraintsCheckedListBox.Location = new System.Drawing.Point(6, 6);
+      this.constraintsCheckedListBox.Name = "constraintsCheckedListBox";
+      this.constraintsCheckedListBox.Size = new System.Drawing.Size(812, 214);
+      this.constraintsCheckedListBox.Sorted = true;
+      this.constraintsCheckedListBox.TabIndex = 0;
       // 
       // resultsGroupBox
@@ -291,39 +326,4 @@
       this.filtersInfoLabel.Text = "Loading Filters ...";
       this.filtersInfoLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
-      // 
-      // constraintsCheckedListBox
-      // 
-      this.constraintsCheckedListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.constraintsCheckedListBox.CheckOnClick = true;
-      this.constraintsCheckedListBox.FormattingEnabled = true;
-      this.constraintsCheckedListBox.Location = new System.Drawing.Point(6, 6);
-      this.constraintsCheckedListBox.Name = "constraintsCheckedListBox";
-      this.constraintsCheckedListBox.Size = new System.Drawing.Size(812, 214);
-      this.constraintsCheckedListBox.Sorted = true;
-      this.constraintsCheckedListBox.TabIndex = 0;
-      // 
-      // selectAllButton
-      // 
-      this.selectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.selectAllButton.Location = new System.Drawing.Point(6, 221);
-      this.selectAllButton.Name = "selectAllButton";
-      this.selectAllButton.Size = new System.Drawing.Size(75, 23);
-      this.selectAllButton.TabIndex = 1;
-      this.selectAllButton.Text = "Select all";
-      this.selectAllButton.UseVisualStyleBackColor = true;
-      this.selectAllButton.Click += new System.EventHandler(this.selectAllButton_Click);
-      // 
-      // deselectAllButton
-      // 
-      this.deselectAllButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.deselectAllButton.Location = new System.Drawing.Point(88, 221);
-      this.deselectAllButton.Name = "deselectAllButton";
-      this.deselectAllButton.Size = new System.Drawing.Size(75, 23);
-      this.deselectAllButton.TabIndex = 2;
-      this.deselectAllButton.Text = "Deselect all";
-      this.deselectAllButton.UseVisualStyleBackColor = true;
-      this.deselectAllButton.Click += new System.EventHandler(this.deselectAllButton_Click);
       // 
       // QueryView
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBExperimentUploadView.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBExperimentUploadView.cs	(revision 7589)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBExperimentUploadView.cs	(revision 7590)
@@ -89,4 +89,5 @@
       foreach (var run in Content.Runs) {
         OKBRunConfigSelectionView orcsv = new OKBRunConfigSelectionView(run, algorithms, problems);
+        orcsv.Anchor = AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
         runConfigViews.Add(orcsv);
         tableLayoutPanel.Controls.Add(orcsv);
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBRunConfigSelectionView.Designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBRunConfigSelectionView.Designer.cs	(revision 7589)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBRunConfigSelectionView.Designer.cs	(revision 7590)
@@ -41,5 +41,5 @@
       this.lblRunName.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.lblRunName.AutoSize = true;
-      this.lblRunName.Location = new System.Drawing.Point(40, 7);
+      this.lblRunName.Location = new System.Drawing.Point(39, 7);
       this.lblRunName.Name = "lblRunName";
       this.lblRunName.Size = new System.Drawing.Size(61, 13);
@@ -49,20 +49,22 @@
       // cmbAlgorithm
       // 
-      this.cmbAlgorithm.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.cmbAlgorithm.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.cmbAlgorithm.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.cmbAlgorithm.FormattingEnabled = true;
-      this.cmbAlgorithm.Location = new System.Drawing.Point(426, 3);
+      this.cmbAlgorithm.Location = new System.Drawing.Point(423, 3);
       this.cmbAlgorithm.Name = "cmbAlgorithm";
-      this.cmbAlgorithm.Size = new System.Drawing.Size(135, 21);
+      this.cmbAlgorithm.Size = new System.Drawing.Size(134, 21);
       this.cmbAlgorithm.TabIndex = 1;
       // 
       // cmbProblem
       // 
-      this.cmbProblem.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.cmbProblem.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.cmbProblem.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.cmbProblem.FormattingEnabled = true;
-      this.cmbProblem.Location = new System.Drawing.Point(708, 3);
+      this.cmbProblem.Location = new System.Drawing.Point(703, 3);
       this.cmbProblem.Name = "cmbProblem";
-      this.cmbProblem.Size = new System.Drawing.Size(135, 21);
+      this.cmbProblem.Size = new System.Drawing.Size(134, 21);
       this.cmbProblem.TabIndex = 2;
       // 
@@ -71,5 +73,5 @@
       this.label1.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(313, 7);
+      this.label1.Location = new System.Drawing.Point(311, 7);
       this.label1.Name = "label1";
       this.label1.Size = new System.Drawing.Size(78, 13);
@@ -88,5 +90,5 @@
       this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
       this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 16.66667F));
-      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 39F));
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 45F));
       this.tableLayoutPanel1.Controls.Add(this.lblRunName, 0, 0);
       this.tableLayoutPanel1.Controls.Add(this.cmbProblem, 5, 0);
@@ -105,8 +107,9 @@
       // txtRunName
       // 
-      this.txtRunName.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.txtRunName.Location = new System.Drawing.Point(144, 3);
+      this.txtRunName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtRunName.Location = new System.Drawing.Point(143, 3);
       this.txtRunName.Name = "txtRunName";
-      this.txtRunName.Size = new System.Drawing.Size(135, 20);
+      this.txtRunName.Size = new System.Drawing.Size(134, 20);
       this.txtRunName.TabIndex = 4;
       // 
@@ -115,5 +118,5 @@
       this.label2.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(598, 7);
+      this.label2.Location = new System.Drawing.Point(593, 7);
       this.label2.Name = "label2";
       this.label2.Size = new System.Drawing.Size(73, 13);
@@ -127,5 +130,5 @@
       this.chkUpload.Checked = true;
       this.chkUpload.CheckState = System.Windows.Forms.CheckState.Checked;
-      this.chkUpload.Location = new System.Drawing.Point(861, 6);
+      this.chkUpload.Location = new System.Drawing.Point(858, 6);
       this.chkUpload.Name = "chkUpload";
       this.chkUpload.Size = new System.Drawing.Size(15, 14);