Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/AdministratorMenuItem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/AdministratorMenuItem.cs	(revision 7591)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/AdministratorMenuItem.cs	(revision 7592)
@@ -21,4 +21,5 @@
 
 using System.Collections.Generic;
+using System.Windows.Forms;
 using HeuristicLab.MainForm;
 using HeuristicLab.Optimizer;
@@ -37,5 +38,9 @@
 
     public override void Execute() {
-      MainFormManager.MainForm.ShowContent(AdministrationClient.Instance);
+      if (OKBRoles.CheckAdminUserPermissions()) {
+        MainFormManager.MainForm.ShowContent(AdministrationClient.Instance);
+      } else {
+        MessageBox.Show("You don't have the permissions for administrating the OKB.", "Security check failed", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+      }
     }
   }
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 7591)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 7592)
@@ -202,4 +202,5 @@
       <DependentUpon>ProblemView.cs</DependentUpon>
     </Compile>
+    <Compile Include="OKBRoles.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Query\QueryClient.cs" />
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBRoles.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBRoles.cs	(revision 7592)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBRoles.cs	(revision 7592)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Clients.Access;
+
+namespace HeuristicLab.Clients.OKB {
+  public static class OKBRoles {
+    public const string OKBUser = "OKB User";
+    public const string OKBAdministrator = "OKB Administrator";
+
+    public static bool CheckUserPermissions() {
+      if (UserInformation.Instance.UserExists) {
+        if (UserInformation.Instance.Roles.Count(x => x.Name == OKBRoles.OKBUser || x.Name == OKBRoles.OKBAdministrator) > 0) {
+          return true;
+        }
+      }
+      return false;
+    }
+
+    public static bool CheckAdminUserPermissions() {
+      if (UserInformation.Instance.UserExists) {
+        if (UserInformation.Instance.Roles.Count(x => x.Name == OKBRoles.OKBAdministrator) > 0) {
+          return true;
+        }
+      }
+      return false;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/CreateFromExperimentMenuItem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/CreateFromExperimentMenuItem.cs	(revision 7591)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/CreateFromExperimentMenuItem.cs	(revision 7592)
@@ -40,5 +40,5 @@
     protected override void OnActiveViewChanged(object sender, EventArgs e) {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      ToolStripItem.Enabled = (activeView != null) && (activeView.Content != null) && (activeView.Content is Experiment) && !activeView.Locked;
+      ToolStripItem.Enabled = (activeView != null) && (activeView.Content != null) && (activeView.Content is Experiment) && !activeView.Locked && OKBRoles.CheckUserPermissions();
     }
 
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBAlgorithm.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBAlgorithm.cs	(revision 7591)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBAlgorithm.cs	(revision 7592)
@@ -200,6 +200,18 @@
       runs = new RunCollection();
       storeRunsAutomatically = true;
-      UserId = UserInformation.Instance.User.Id;
+      CheckUserPermissions();
       RegisterRunsEvents();
+    }
+
+    private void CheckUserPermissions() {
+      if (UserInformation.Instance.UserExists) {
+        if (UserInformation.Instance.Roles.Count(x => x.Name == OKBRoles.OKBUser || x.Name == OKBRoles.OKBAdministrator) > 0) {
+          UserId = UserInformation.Instance.User.Id;
+        } else {
+          throw new Exception("You don't have the appropriate roles for executing OKB Algorithms.");
+        }
+      } else {
+        throw new Exception("You need an user account for executing OKB Algorithms.");
+      }
     }
 